﻿// Matt's TinyMVC Copyright (c) 2009 Matt J. Crouch

// Permission is hereby granted, free of charge, to any person obtaining a copy of this software
// and associated documentation files (the "Software"), to deal in the Software without restriction, 
// including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, 
// and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, 
// subject to the following conditions:

// The above copyright notice and this permission notice shall be included in all copies
// or substantial portions of the Software.

// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT
// LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN 
// NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, 
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
// SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using MattsTinyMVC;

namespace MattsTinyMVCTest
{
    public class TestModel : BaseModel
    {
        public TestModel() : base()
        {
        }

        public int Property1 { get; set; }
        public string Property2 { get; set; }
        public DateTime Property3 { get; set; }
        public bool Property4 { get; set; }
        public decimal Property5 { get; set; }

        [TrackModels]
        internal ObservableCollection<TestModel> _subModels = null;
        public IEnumerable<TestModel> SubModels
        {
            get { return _subModels; }
        }

        public void AddNewModel()
        {
            TestModel newModel = new TestModel();
            _subModels.Add(newModel);
        }

        public void AddNewModel(TestModel newModel)
        {
            _subModels.Add(newModel);
        }

        public void TestCommand()
        {
            Property1 = Environment.TickCount;
        }

        public void Remove()
        {
            TestController testController = this.Parent as TestController;
            if (testController != null)
                testController._controllerModels.Remove(this);
            else
            {
                TestModel parentTestModel = this.Parent as TestModel;
                if (parentTestModel != null)
                    parentTestModel._subModels.Remove(this);
            }
        }
    }
}
